<?php

namespace App\Models;

use DB;

class Ctacte
{
    public function __construct(
        $rut_empresa,
        $rut_c,
        $n_doc_ctacte,
        $tipo_doc,
        $total_ctacte,
        $pagos_ctacte,
        $saldo_ctacte,
        $id_empresa,
        $libro_ventas_id
    )
    {
        $this->rut_empresa = $rut_empresa;
        $this->rut_c = $rut_c;
        $this->n_doc_ctacte = $n_doc_ctacte;
        $this->tipo_doc = $tipo_doc;
        $this->total_ctacte = $total_ctacte;
        $this->pagos_ctacte = $pagos_ctacte;
        $this->saldo_ctacte = $saldo_ctacte;
        $this->id_empresa = $id_empresa;
        $this->libro_ventas_id = $libro_ventas_id;
    }

    

    protected function EstadoModuloTesoreria()
    {

        $estado = DB::table('modulos_empresas')
            ->whereRaw('ID_EMPRESA = \''. $this->rut_empresa.'\'')
            ->first();
        
        return $estado->MODULO3;
        
    }

    public function ingresar($id_libro_venta)
    {
        
        try{
            $ingreso = 'true';
                
            if ($this->EstadoModuloTesoreria()) {
                $ingreso = DB::table('ctacte')
                    ->insertGetId([
                        'rut_empresa' => $this->rut_empresa,
                        'rut_c' => $this->rut_c,
                        'n_doc_ctacte' => $this->n_doc_ctacte,
                        'tipo_doc' => $this->tipo_doc,
                        'total_ctacte' => $this->total_ctacte,
                        'pagos_ctacte' => 0,
                        'saldo_ctacte' => $this->total_ctacte,
                        'datos_empresa_id' => $this->id_empresa,
                        'libro_ventas_id' => $id_libro_venta,
                    ]);
            }
        }catch (Exception $e){
            return false;
        }
        
        return $ingreso;
        
    }
    
}
